(kuangbin带你飞--基础DP)Super Jumping! Jumping! Jumping! HDU 1087

原题目:

Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.



The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.
Your task is to output the maximum value according to the given chessmen list.

Input

Input contains multiple test cases. Each test case is described in a line as follow:
N value_1 value_2 …value_N
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
A test case starting with 0 terminates the input and this test case is not to be processed.

Output

For each case, print the maximum according to rules, and one line one case.

Sample Input

3 1 3 2
4 1 2 3 4
4 3 3 2 1
0

Sample Output

4
10
3

中文概要:

求最大上升子序列的和

#include<iostream>
using namespace std;

const int maxn = 1005;
int n;
int a[maxn];
int dp[maxn];

int Dp()
{
	for(int i = 1;i <= n;i++)
	{
		if(i == 1)
			dp[i] = a[i];
		else if(i > 1)
		{
			int max_res = 0;
			for(int k = 1;k <= i - 1;k++)
			{
				if(a[k] < a[i])
				{
					if(dp[k] > max_res)
						max_res = dp[k];
				}
			}
			dp[i] = max_res + a[i];
		}
	}
	int max_r = 0;
	for(int i = 1;i <= n;i++)
	{
		if(dp[i] > max_r)
			max_r = dp[i];
	}
	return max_r;
}

void Clear()
{
	for(int i = 1;i <= n;i++)
		dp[i] = 0;
}

int main()
{
	while(scanf("%d", &n) && n != 0)
	{
		Clear();
		for(int i = 1;i <= n;i++)
		{
			cin >> a[i];
		}
		cout << Dp() << endl;
	}
	return 0;
}

思路:

看了老半天发现原来的思路不对,以前看这种DP问题的思路都错了,看懂才恍然大悟啊,真的想不出来,挺厉害的。

对于序列a : 1  3  2
它的各项dp值为:  1   4  3
最后我们只需要遍历一遍dp数组找到最大的那个dp值返回就是答案了!
然后我们来推状态转移方程,首先考虑边界条件,即i == 1的情况,也就是第一项你怎么赋值。我们分析发现第一项的最大递增子序列和肯定是等于自己的,所以dp[1] = a[1]。
然后再考虑i > 1的情况。经过分析,当i > 1时,它的dp[i]的取值和它前面几项的值都有着密切的关系。
对于序列: 3, 1, 5, 4, 6, 2, 3, 8
它的值为: 3 , 1, 6, 7, 13, 3, 6, 21, 1
我们发现dp[i]的值等于小于a[i]的值里面,dp值最大的那个加上a[i]。(这句话十分重要,是整道题的解决思路)!!!!!!
写专业点,状态方程就是 : dp[j]=max{dp[i]}+a[j]; 其中,0<=i<=j,a[i]<a[j]

等知道dp[]怎么来求的时候问题就不难了
 

 

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值